import { Config } from "./interfaces/Config";
import { QuickSendMessage } from "./interfaces/QuickSendMessage";
import { SendMessage } from "./interfaces/SendMessage";
import { ScheduleMessage } from "./interfaces/ScheduleMessage";
import { SendMessageResponse } from "./interfaces/SendMessageResponse";
import { Message } from "./interfaces/Message";
import { QueryMessageResponse } from "./interfaces/QueryMessageResponse";
import { CancelScheduledMessageResponse } from "./interfaces/CancelScheduledMessageResponse";
export declare class HubtelSms {
    private readonly config;
    private headers;
    constructor(config: Partial<Config>);
    quickSend: (data: QuickSendMessage) => Promise<SendMessageResponse>;
    sendMessage: (data: SendMessage) => Promise<any>;
    getMessage: (messageId: string) => Promise<Message>;
    queryMessage: () => Promise<QueryMessageResponse>;
    scheduleMessage: (data: ScheduleMessage) => Promise<SendMessageResponse>;
    rescheduleScheduledMessage: (messageId: string, time: string) => Promise<SendMessageResponse>;
    cancelScheduledMessage: (messageId: string) => Promise<CancelScheduledMessageResponse>;
}
