"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const axios_1 = __importDefault(require("axios"));
const querystring_1 = __importDefault(require("querystring"));
const helper_1 = require("./utils/helper");
const BASE_URL = "https://api.hubtel.com/v1/messages";
class HubtelSms {
    constructor(config) {
        this.config = config;
        this.quickSend = (data) => __awaiter(this, void 0, void 0, function* () {
            try {
                const response = yield axios_1.default.get(`${BASE_URL}/send?${querystring_1.default.stringify(data)}&ClientId=${this.config.clientId}&ClientSecret=${this.config.clientSecret}`);
                return response.data;
            }
            catch (err) {
                throw err;
            }
        });
        this.sendMessage = (data) => __awaiter(this, void 0, void 0, function* () {
            try {
                const response = yield axios_1.default.post(`${BASE_URL}`, data, {
                    headers: this.headers
                });
                return response.data;
            }
            catch (err) {
                throw err;
            }
        });
        this.getMessage = (messageId) => __awaiter(this, void 0, void 0, function* () {
            try {
                const response = yield axios_1.default.get(`${BASE_URL}/${messageId}`, {
                    headers: this.headers
                });
                return response.data;
            }
            catch (err) {
                throw err;
            }
        });
        this.queryMessage = () => __awaiter(this, void 0, void 0, function* () {
            try {
                const response = yield axios_1.default.get(`${BASE_URL}`, {
                    headers: this.headers
                });
                return response.data;
            }
            catch (err) {
                throw err;
            }
        });
        this.scheduleMessage = (data) => __awaiter(this, void 0, void 0, function* () {
            try {
                const response = yield axios_1.default.post(`${BASE_URL}`, data, {
                    headers: this.headers
                });
                return response.data;
            }
            catch (err) {
                throw err;
            }
        });
        //Not Working
        this.rescheduleScheduledMessage = (messageId, time) => __awaiter(this, void 0, void 0, function* () {
            try {
                const response = yield axios_1.default.put(`${BASE_URL}/${messageId}`, { Time: time }, {
                    headers: this.headers
                });
                return response.data;
            }
            catch (err) {
                throw err;
            }
        });
        this.cancelScheduledMessage = (messageId) => __awaiter(this, void 0, void 0, function* () {
            try {
                const response = yield axios_1.default.delete(`${BASE_URL}/${messageId}`, {
                    headers: this.headers
                });
                return response.data;
            }
            catch (err) {
                throw err;
            }
        });
        if (!(config.clientId && config.clientSecret)) {
            throw new Error("Invalid Configuration");
        }
        this.headers = Object.assign({}, helper_1.getCommonHeaders(this.config.clientId, this.config.clientSecret));
    }
}
exports.HubtelSms = HubtelSms;
